<?php

namespace EventPortal\Tests\Support\Traits;

use EventPortal\Domain\Team\Models\Team;
use Illuminate\Database\Eloquent\Model;

trait InteractsWithTeams
{
    /**
     * @param array<Model> $models
     * @param ?Team $team
     * @return array
     */
    public function addToSameTeam(array $models, ?Team $team = null): array
    {
        $team = $team ?? factory(Team::class)->create();

        return collect($models)->each(static function ($model) use ($team): void {
            $model->teams()->attach($team->id);
        })->all();
    }
}
